%define _unpackaged_files_terminate_build 0
%define glibcrelease 2.2.4.32.5
Summary: Compatibility C library
Name: compat-glibc
Version: 7.x
ExclusiveArch: i386 ia64
Release: %{glibcrelease}
Copyright: LGPL
Group: System Environment/Libraries
Source: glibc-2.2.4.tar.bz2
# In the source tarball the file diff-CYGNUS-to-REDHAT.patch contains all
# diffs applied by Red Hat to the current CVS version of glibc
Buildroot: %{_tmppath}/glibc-%{PACKAGE_VERSION}-root
Autoreq: true
# This is for building auxiliary programs like memusage
# For initial glibc bootstraps it can be commented out
BuildPreReq: gd-devel libpng-devel zlib-devel
BuildPreReq: compat-gcc >= 7.3
AutoProv: false
Patch2: glibc-2.2.4.patch
Source2: glibc-aio.patch
Patch3: glibc-2.2.4-fixes.patch
Patch4: glibc-2.2.4-s390.patch
Patch5: glibc-2.2.4-i386-postupgrade.patch
Patch6: glibc-2.2.4-s390-2.patch
Patch7: glibc-2.2.4-security.patch
Patch8: glibc-2.2.4-ia64-strncpy.patch
Patch9: glibc-2.2.4-sunrpc.patch
Patch10: glibc-2.2.4-collate.patch
Patch11: glibc-2.2.4-fixes2.patch
Patch12: glibc-2.2.4-xdr_array.patch
Patch13: glibc-2.2.4-calloc.patch
Patch14: glibc-2.2.4-ia64-sigwrap.patch
Patch15: glibc-2.2.4-gmon-start.patch
Patch16: glibc-2.2.4-ia64-strncpy2.patch
Patch17: glibc-2.2.4-maxpacket-v2.patch
Patch18: glibc-2.2.4-maxthread.patch
Patch19: glibc-2.2.4-onexit-process.patch
Patch20: glibc-2.2.4-setrlimit.patch
Patch21: glibc-2.2.4-wprintf.patch
Patch22: glibc-2.2.4-ia64-sigstksz.patch
Patch23: glibc-2.2.4-ia64-make-fdesc.patch
Patch24: glibc-2.2.4-printf-prec0.patch
Patch25: glibc-2.2.4-ia64-strncpy3.patch
Patch26: glibc-2.2.4-ia64-ldd.patch
Patch27: glibc-2.2.4-writev.patch
Patch28: glibc-2.2.4-grantpt.patch
Patch29: glibc-2.2.4-ftw.patch
Patch30: glibc-2.2.4-cancelrace.patch
Patch31: glibc-2.2.4-ia64-strncpy4.patch
Patch32: glibc-2.2.4-nscd-hstcache.patch
Patch33: glibc-2.2.4-xdrmem.patch
Patch34: glibc-2.2.4-hosts.patch
Patch35: glibc-2.2.4-ia64-unwind.patch
Patch36: glibc-2.2.4-maxthread-debug.patch
%ifarch ia64 sparc64 s390x
Conflicts: kernel < 2.4.0
%define enablekernel 2.4.0
%define enablemask [01].*|2.[0-3]*
%else
%define enablekernel 2.2.5
%define enablemask [01].*|2.[0-1]*|2.2.[0-4]|2.2.[0-4][^0-9]*
%endif

%description
This package contains stub shared libraries, static libraries and
headers from Red Hat Linux 7.2 and Red Hat Enterprise Linux 2.1.
To compile and link against these compatibility libraries, use
gcc296 -I %{_prefix}/lib/%{_target_cpu}-redhat-linux7/include \
       -B %{_prefix}/lib/%{_target_cpu}-redhat-linux7/lib/

%prep
%setup -q -n glibc-2.2.4
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%ifarch s390 s390x
%patch6 -p1
%endif
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1

%ifarch armv4l sparc64 ia64 s390 s390x
rm -rf glibc-compat
%endif

# Waiting for explanation...
rm -f sysdeps/powerpc/memset.S

# Bug #86439
rm -f sysdeps/ia64/memccpy.S

find . -type f -size 0 -o -name "*.orig" -exec rm -f {} \;

%build
rm -rf build-%{_target_cpu}-linux
mkdir build-%{_target_cpu}-linux ; cd build-%{_target_cpu}-linux
GCC=gcc296
%ifarch %{ix86}
BuildFlags="-march=%{_target_cpu} -D__USE_STRING_INLINES -fstrict-aliasing"
%endif
%ifarch alphaev6
BuildFlags="-mcpu=ev6"
%endif
%ifarch sparc
BuildFlags="-fcall-used-g7"
GCC="gcc -m32"
%endif
%ifarch sparcv9
BuildFlags="-mcpu=ultrasparc -fcall-used-g7"
GCC="gcc -m32"
%endif
%ifarch sparc64
BuildFlags="-mcpu=ultrasparc -mvis -fcall-used-g7"
GCC="gcc -m64"
%endif
# Temporarily don't do this on ia64 and s390
%ifnarch ia64 s390 s390x
BuildFlags="$BuildFlags -freorder-blocks"
%endif
BuildFlags="$BuildFlags -DNDEBUG=1"
EnableKernel="--enable-kernel=%{enablekernel} --disable-profile"
echo "$BuildFlags" > ../BuildFlags
CC="$GCC" CFLAGS="$BuildFlags -g -O3" ../configure --prefix=%{_prefix} \
	--enable-add-ons=yes --without-cvs $EnableKernel \
	%{_target_cpu}-redhat-linux
if [ -x /usr/bin/getconf ] ; then
  numprocs=$(/usr/bin/getconf _NPROCESSORS_ONLN)
  if [ $numprocs -eq 0 ]; then
    numprocs=1
  fi
else
  numprocs=1
fi
make -j$numprocs -r CFLAGS="$BuildFlags -g -O3" PARALLELMFLAGS=-s

%install
if [ -x /usr/bin/getconf ] ; then
  numprocs=$(/usr/bin/getconf _NPROCESSORS_ONLN)
  if [ $numprocs -eq 0 ]; then
    numprocs=1
  fi
else
  numprocs=1
fi
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
make install_root=$RPM_BUILD_ROOT install -C build-%{_target_cpu}-linux

# Remove the files we don't want to distribute
rm -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libNoVersion*
%ifarch sparc64 ia64 s390 s390x
rm -f $RPM_BUILD_ROOT/%{_lib}/libNoVersion*
%endif
rm -rf $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libnss*.so
rm -rf $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libBrokenLocale*.so

COMPATD=$RPM_BUILD_ROOT%{_prefix}/lib/%{_target_cpu}-redhat-linux7

mkdir -p $COMPATD/%{_lib}

mv -f $RPM_BUILD_ROOT%{_prefix}/include $COMPATD/
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/*.[oa] $COMPATD/%{_lib}
strip -R .comment -g $COMPATD/%{_lib}/*.a
ln -sf libbsd-compat.a $COMPATD/%{_lib}/libbsd.a
mkdir -p $RPM_BUILD_ROOT%{_prefix}/tmp
cp -a $RPM_BUILD_ROOT%{_prefix}/%{_lib}/*.so $RPM_BUILD_ROOT%{_prefix}/tmp
rm -f $RPM_BUILD_ROOT%{_prefix}/tmp/libc.so
pushd $RPM_BUILD_ROOT%{_prefix}/tmp
ln -sf ../../%{_lib}/libc.so.6* libc.so
popd
cd build-%{_target_cpu}-linux

for libpath in $RPM_BUILD_ROOT%{_prefix}/tmp/*.so; do
  lib=`basename $libpath .so`
  readelf -Ws $libpath | awk '
/\.dynsym.* contains/ { start=1 }
/^$/ { start=0 }
/  UND / { next }
/@/ { if (start) {
  fn=$8
  intfn="HACK" hack+0
  hack++
  if ($4 ~ /FUNC/) { print ".text"; size=16; print ".type " intfn ",@function" }
  else if ($4 ~ /OBJECT/) { print ".data"; size=$3; print ".type " intfn ",@object" }
  else if ($4 ~ /NOTYPE/) { print ".data"; size=$3 }
  else exit(1);
  print ".globl " intfn
  if ($5 ~ /WEAK/) { print ".weak " intfn }
  else if ($5 !~ /GLOBAL/) exit(1);
  print intfn ": .skip " size
  print ".size " intfn "," size
  print ".symver " intfn "," fn
} }
' > $lib.s || exit
  soname=`readelf -Wd $libpath | grep SONAME | sed 's/^.*\[//;s/\].*$//'`
  gcc -shared -Wl,-soname,$soname,-version-script,$lib.map \
    -o $COMPATD/%{_lib}/$lib.so $lib.s -nostdlib
  strip $COMPATD/%{_lib}/$lib.so
done
mv $COMPATD/%{_lib}/libc.so $COMPATD/%{_lib}/libc_real.so
mv $COMPATD/%{_lib}/librt.so $COMPATD/%{_lib}/librt_real.so
LDIR=%{_prefix}/lib/%{_target_cpu}-redhat-linux7/%{_lib}
cat > $COMPATD/%{_lib}/libc.so <<EOF
/* GNU ld script
   Use the shared library, but some functions are only in
   the static library, so try that secondarily.  */
GROUP ( $LDIR/libc_real.so $LDIR/libc_nonshared.a )
EOF
cat > $COMPATD/%{_lib}/librt.so <<EOF
/* GNU ld script
   librt.so.1 needs libpthread.so.0 to come before libc.so.6*
   in search scope.  */
GROUP ( $LDIR/libpthread.so $LDIR/librt_real.so )
EOF

cd ..

%clean
rm -rf "$RPM_BUILD_ROOT"

%files
%defattr(-,root,root)
%dir %{_prefix}/lib/%{_target_cpu}-redhat-linux7
%dir %{_prefix}/lib/%{_target_cpu}-redhat-linux7/%{_lib}
%{_prefix}/lib/%{_target_cpu}-redhat-linux7/include
%{_prefix}/lib/%{_target_cpu}-redhat-linux7/%{_lib}/*.[oa]
%{_prefix}/lib/%{_target_cpu}-redhat-linux7/%{_lib}/*.so

%changelog
* Tue Jun  3 2003 Jakub Jelinek <jakub@redhat.com> 7.x-2.2.4.32.5
- update description

* Tue Jun  3 2003 Jakub Jelinek <jakub@redhat.com> 7.x-2.2.4.32.4
- fix libc_real.so stub

* Mon Jun  2 2003 Jakub Jelinek <jakub@redhat.com> 7.x-2.2.4.32.3
- turn into compatibility package
